#include <stdio.h>
#include <string.h>
#ifdef WIN32
#include <winsock.h>
#endif
#include "sock.h"

extern	char	*getenv(char *);

struct	_conn {
	char	proto[64];
	char	host[128];
	char	page[1024];
	int	port;
} cnct;

int	parse_url(struct _conn *dst, char *p)
{
	char	*d;

	if(strncmp(p, "http:", 5)) {
	    return 0;
	}
	strcpy(dst->proto, "http");
	dst->port = 80;
	p += 5;
	if(*p == '/' && p[1] == '/') {
	    p += 2;
	    d = dst->host;
	    while(*p && *p != '/' && *p != ':')
		*d++ = *p++;
	    *d = 0;
	    if(*p == ':') {
		dst->port = atoi(p + 1);
		if(!dst->port)
		    dst->port = 80;
		while(*p && *p != '/') ++p;
	    }
	    /* p points to the first '/' in page name */
	}
	strncpy(dst->page, p, sizeof(dst->page));
	dst->page[sizeof(dst->page) - 1] = 0;
	return 1;
}

int	wget(FILE *fp, char *url)
{
	conn	*cp;
	char	buff[4096];
	char	cmd[256];
	struct _conn proxy;

/*	strcpy(buff,
	    "http://bahn.hafas.de/bin/bhftafel.exe/en/8300654/12:00/an?P=95&ld=106&seqnr=&ident=&");
	url = buff; */
	if(!parse_url(&cnct, url)) {
	    printf("Cannor parse URL '%s'\r\n");
	    return 0;
	}
	proxy = cnct;
	if(getenv("PROXY") && !parse_url(&proxy, getenv("PROXY"))) {
	    printf("Cannot parse proxy '%s'\r\n", getenv("PROXY"));
	    return 0;
	}
	if(!(cp = socket_connect(proxy.host, proxy.port))) {
	    printf("Cannot connect to %s:%d\r\n", cnct.host, cnct.port);
	    return 0;
	}
	sprintf(cmd, "GET %s://%s%s HTTP/1.0\r\n\r\n", cnct.proto, cnct.host, cnct.page);
	sock_sendcmd(cp, cmd);
	sock_rdline(cp, buff);		/* throw away reply from server */
	while(sock_rdline(cp, buff))
	    fprintf(fp, "%s", buff);
	closesocket(cp->sock);
	return 1;
}

